# `0 <= x /\ 0 <= y /\ 0 <= z /\ (x * y * z = 1) ==> x + y + z <= x2 * z + y2 * x + z2 * y`;;

load 'solve_sos_equation.sage'
load 'prepare_polynomials.sage'

indeterminates=['x', 'y', 'z']
polynomial_ring=PolynomialRing(QQ, indeterminates)

conseq =   polynomial_ring('(x^2 * z + y^2 * x + z^2 * y) - (x+y+z)')

positive_monomial_list=monomial_basis(3)
positive_polynomials1=[polynomial_ring('x'), polynomial_ring('y'), polynomial_ring('z'),-conseq]
positive_polynomials=positive_polynomials1
positive_monomial_lists=[positive_monomial_list for p in positive_polynomials]

equality_polynomials=[polynomial_ring('x*y*z-1')]
equality_monomial_list=monomial_basis(8)
equality_monomial_lists=[equality_monomial_list for p in equality_polynomials]

rhs_polynomial=conseq

solution = solve_sos_equation_sos(polynomial_ring, positive_polynomials, positive_monomial_lists, equality_polynomials, equality_monomial_lists, rhs_polynomial)

def apply_sos_solution(pblocks, eblocks):
  assert(len(pblocks) == len(positive_monomial_lists))
  assert(len(pblocks) == len(positive_polynomials))
  assert(len(eblocks) == len(equality_monomial_lists))
  assert(len(eblocks) == len(equality_polynomials))

  total = polynomial_ring(0)
  for (sos, poly, monomials) in zip(pblocks, positive_polynomials, positive_monomial_lists):
    total += poly * apply_sos(sos, monomials)
  for (lin, poly, monomials) in zip(eblocks, equality_polynomials, equality_monomial_lists):
    total += poly * (lin * vector(monomials))
  return total

if solution == ():
  print 'NO SOLUTION'
else:
  (pblocks, eblocks) = solution
  assert(apply_sos_solution(pblocks, eblocks)==rhs_polynomial)
  print 'SOLUTION'
  print 'RHS'
  print rhs_polynomial
  for i in xrange(len(positive_polynomials)):
    print 'POSITIVE POLYNOMIAL', i
    print positive_polynomials[i]
    print 'sos polynomial'
    print apply_sos(pblocks[i], positive_monomial_lists[i])
    print 'summands'
    for coeff, sos in pblocks[i]:
      print coeff, "*(", sum([a*b for a, b in zip(sos, positive_monomial_lists[i])]), ")^2"
  for i in xrange(len(equality_polynomials)):
    print 'ZERO POLYNOMIAL', i
    print equality_polynomials[i]
    print 'factor polynomial'
    print eblocks[i] * vector(equality_monomial_lists[i])
