# This file was *autogenerated* from the file prove_nonnegativeness_psatz.sage.
from sage.all_cmdline import *   # import sage library
_sage_const_2 = Integer(2); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_1e14 = RealNumber('1e14')
sage.misc.preparser.load(sage.misc.preparser.base64.b64decode("J3NvbHZlX3Nvc19lcXVhdGlvbi5zYWdlJw=="),globals(),False)
sage.misc.preparser.load(sage.misc.preparser.base64.b64decode("J3ByZXBhcmVfcG9seW5vbWlhbHMuc2FnZSc="),globals(),False)

# Examples from Reznick, Some concrete aspects of Hilbert's 17th problem
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x','y']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('(11*x+y)^4')
  exponent = _sage_const_0 
  kernel_scaling = _sage_const_1e14 

# Motzkin M
if _sage_const_1 ==_sage_const_1 :
  indeterminates=['x', 'y', 'z']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x^4 * y^2 + x^2 * y^4 + z^6 - 3 * x^2 * y^2 * z^2')
  kernel_scaling = _sage_const_1e14 
  exponent = _sage_const_2 

# Robinson R
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x', 'y', 'z']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x^6 + y^6 + z^6 - (x^4 * y^2 + x^2 * y^4 + x^4 * z^2 + x^2 * z^4 + y^4 * z^2 + y^2 * z^4) + 3 * x^2 * y^2 * z^2')
  den_degree = _sage_const_1 

# Robinson f
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x','y','z','w']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x^2 * (x-w)^2 + y^2 * (y-w)^2 + z^2 * (z-w)^2 + 2*x*y*z * (x+y+z-2*w)')
  den_degree = _sage_const_1 

# Choi-Lam F works (with scaling factor 10^15 or nonzero init)
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x1','x2','x3','y1','y2','y3']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x1^2 * y1^2 + x2^2 * y2^2 + x3^2 * y3^2 + 2*(x1^2 * y2^2 + x2^2 * y3^2 + x3^2 * y1^2) - 2*x1*x2*y1*y2 - 2*x1*x3*y1*y3 - 2*x2*x3*y2*y3')
  den_degree=_sage_const_1 

# Choi-Lam Q
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x', 'y', 'z', 'w']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x^2*y^2 + x^2*z^2 + y^2*z^2 + w^4 -4*w*x*y*z')
  den_degree=_sage_const_1 

# Choi-Lam S
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x', 'y', 'z']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x^4 * y^2 + y^4 * z^2 + z^4 * x^2 - 3*x^2*y^2*z^2')
  den_degree=_sage_const_1 

# Choi-Lam H
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x1', 'x2', 'x3', 'x4', 'x5']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('(x1^2 + x2^2 + x3^2 + x4^2 + x5^2)^2 - 4* (x1^2 * x2^2 + x2^2 * x3^2 + x3^2 * x4^2 + x4^2 * x5^2 + x5^2 * x1^2)');
  den_degree = _sage_const_1 
    
# Schmuedgen q
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x','y','z']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('200*(x^3-4*x*z^2)^2 + 200*(y^3-4*y*z^2)^2 + (y^2-x^2)*x*(x+2*z)*(x^2-2*x*z+2*y^2-8*z^2)')
  den_degree=_sage_const_1 

# Delzell
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x1','x2','x3','x4']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x1^4 * x2^2 * x4^2 + x2^4 * x3^2 * x4^2 + x1^2 * x3^4 * x4^2 -3 * x1^2 * x2^2 * x3^2 * x4^2 + x3^8')
  den_degree=_sage_const_1 

# Lax-Lax
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x1','x2','x3','x4']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('x1*x2*x3*x4') - sum([polynomial_ring(xi) * prod([polynomial_ring(xj)-polynomial_ring(xi) for xj in indeterminates if xj!=xi]) for xi in indeterminates])
  den_degree=_sage_const_1 

# Leep-Starr2
if _sage_const_1 ==_sage_const_0 :
  indeterminates=['x1','x2']
  polynomial_ring=PolynomialRing(QQ, indeterminates)
  polynomial = polynomial_ring('8 + 1/2 * x1^2 * x2^4 + x1^2 * x2^3 - 2 * x1^3 * x2^3 + 2 * x1 * x2^2 + 10 * x1^2 * x2^2 + 4 * x1^3 * x2^2 + 3 * x1^4 * x2^2 + 4 * x1 * x2 -8 * x1^2 * x2')
  den_degree=_sage_const_1 

# assert(polynomial.is_homogeneous())
assert(polynomial.degree() % _sage_const_2  == _sage_const_0 )

rhs_polynomial = polynomial**(_sage_const_2 *exponent+_sage_const_1 )
degree=rhs_polynomial.degree()/_sage_const_2 
polytope = (rhs_polynomial.newton_polytope())*(_sage_const_1 /_sage_const_2 )

if rhs_polynomial.is_homogeneous():
  monomials1=monomial_basis_homogeneous(degree)
else:
  monomials1=monomial_basis(degree)

monomials=[m for m in monomials1 if polytope.contains(m.exponents()[_sage_const_0 ])]
print "MONOMIALS", monomials

solution= solve_sos_equation_sos(polynomial_ring, [_sage_const_1 ], [monomials], [], [], rhs_polynomial)

print solution
if solution == ():
  print 'NO SOLUTION'
else:
  (solution_q,solution_e) = solution
  num = apply_sos(solution_q[_sage_const_0 ], monomials)
  print 'SOLUTION'
  print 'NUM'
  print num
  print 'summands'
  for coeff, sos in solution_q[_sage_const_0 ]:
    print coeff, "*(", sum([a*b for a, b in zip(sos, monomials)]), ")^2"
