import sys
load 'solve_sos_equation.sage'
load 'prepare_polynomials.sage'

vor_indeterminates=['x','a','x0','y','alpha','beta']
vor_polynomial_ring=PolynomialRing(ZZ, vor_indeterminates)
vor_polynomial = vor_polynomial_ring('\
( -4*x^2*a*alpha - 2*x*x0*a - 4*x*a*alpha - x0*a - a*alpha + 2*x*beta + y + beta )^2 +\
( -2*x*a^2*alpha + 4*x^2*a*beta + 2*x*y*a - x0*a^2 - a^2*alpha + 4*x*a*beta + y*a + a*beta )^2 +\
16 *( x^2*a + x*a )^2')
# unfortunately discriminants only work for variable x

print vor_polynomial

# Voronoi2
indeterminates = ['a','x0','y','alpha','beta']
polynomial_ring=PolynomialRing(ZZ, indeterminates)
ring2 = PolynomialRing(polynomial_ring,'x')
p2=ring2(vor_polynomial).discriminant()
div=polynomial_ring('16*a^4*(a*x0 - y - beta + a*alpha)^2 * (y + a*x0 - a*alpha - beta)^2') # square factors
(polynomial,remainder)=p2.quo_rem(div)
print polynomial.content()
polynomial /= polynomial.content()
assert(remainder==0)
assert(len(polynomial.coefficients())==253)
assert(polynomial.degree()==18)

den_degree=1

print polynomial
sys.stdout.flush()

assert(polynomial.degree() % 2 == 0)

lhs_polynomials=[polynomial, -1]
num_degree=den_degree+polynomial.degree()/2
# if is_symmetric:
#   if (polynomial.is_homogeneous()):
#     print "symmetric + homogeneous"
#     lhs_monomial_lists=[monomial_basis_homogeneous_symmetric(den_degree), monomial_basis_homogeneous(num_degree)]
#   else:
#     print "symmetric + not homogeneous"
#     lhs_monomial_lists=[monomial_basis_symmetric(den_degree), monomial_basis(num_degree)]
# else:
if (polynomial.is_homogeneous()):
  print "homogeneous"
  lhs_monomial_lists=[monomial_basis_homogeneous(den_degree), monomial_basis_homogeneous(num_degree)]
else:
  print "not homogeneous"
  lhs_monomial_lists=[monomial_basis(den_degree), monomial_basis(num_degree)]

rhs_polynomial=polynomial_ring(0)

print 'solving'
sys.stdout.flush()
solution = solve_sos_equation_sos(polynomial_ring, lhs_polynomials, lhs_monomial_lists, [], [], rhs_polynomial)

print 'POLYNOMIAL'
print polynomial
if solution == ():
  print 'NO SOLUTION'
else:
  (solution_q,solution_e) = solution
  den = apply_sos(solution_q[0], lhs_monomial_lists[0])
  num = apply_sos(solution_q[1], lhs_monomial_lists[1])
  if den == 0:
    print 'ZERO SOLUTION'
  else:
    assert(polynomial == num/den)
    print 'SOLUTION'
    print 'NUM'
    print num
    print 'summands'
    for coeff, sos in solution_q[1]:
      print coeff, "*(", sum([a*b for a, b in zip(sos, lhs_monomial_lists[1])]), ")^2"
    print 'DEN'
    print den
    print 'summands'
    for coeff, sos in solution_q[0]:
      print coeff, "*(", sum([a*b for a, b in zip(sos, lhs_monomial_lists[0])]), ")^2"
